---
title: USBEndpoint
slug: Web/API/USBEndpoint
tags:
  - API
  - Interface
  - Reference
  - USB
  - USBEndpoint
  - Web USB API
---
{{securecontext_header}}
<p>The <code>USBEndpoint</code> interface of the <a href="/en-US/docs/Web/API/WebUSB_API">WebUSB API</a> provides information about an endpoint provided by the USB device. An endpoint represents a unidirectional data stream into or out of a device.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt><strong><code>{{domxref("USBEndpoint.USBEndpoint")}}</code></strong></dt>
 <dd>Creates a new <code>USBEndpoint</code> object which will be populated with information about the endpoint on the provided {{domxref('USBAltenateInterface')}} with the given endpoint number and transfer direction.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><strong><code>{{domxref("USBEndpoint.endpointNumber")}}</code></strong></dt>
 <dd>Returns this endpoint's "endpoint number" which is a value from 1 to 15 extracted from the <code>bEndpointAddress</code> field of the endpoint descriptor defining this endpoint. This value is used to identify the endpoint when calling methods on <code>USBDevice</code>.</dd>
 <dt><strong><code>{{domxref("USBEndpoint.direction")}}</code></strong></dt>
 <dd>Returns the direction in which this endpoint transfers data, one of:
 <ul>
  <li><code>"in"</code> - Data is transferred from device to host.</li>
 </ul>

 <ul>
  <li><code>"out"</code> - Data is transferred from host to device.</li>
 </ul>
 </dd>
</dl>

<dl>
 <dt><strong><code>{{domxref("USBEndpoint.type")}}</code></strong></dt>
 <dd>Returns the type of this endpoint, one of:
 <ul>
  <li><code>"bulk"</code> - Provides reliable data transfer for large payloads. Data sent through a bulk endpoint is guaranteed to be delivered or generate an error but may be preempted by other data traffic.</li>
 </ul>

 <ul>
  <li><code>"interrupt"</code> - Provides reliable data transfer for small payloads. Data sent through an interrupt endpoint is guaranteed to be delivered or generate an error and is also given dedicated bus time for transmission.</li>
 </ul>

 <ul>
  <li><code>"isochronous"</code> - Provides unreliable data transfer for payloads that must be delivered periodically. They are given dedicated bus time but if a deadline is missed the data is dropped.</li>
 </ul>
 </dd>
</dl>

<dl>
 <dt><strong><code>{{domxref("USBEndpoint.packetSize")}}</code></strong></dt>
 <dd>Returns the size of the packets that data sent through this endpoint will be divided into.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>While sometimes the developer knows ahead of time the exact layout of a device's endpoints there are cases where this must be discovered at runtime. For example, a USB serial device must provide bulk input and output endpoints but their endpoint numbers will depend on what other interfaces the device provides.</p>

<p>This code identifies the correct endpoints by searching for the interface implementing the USB CDC interface class and then identifying the candidate endpoints based on their type and direction.</p>

<pre class="brush: js">let inEndpoint = undefined;
let outEndpoint = undefined;

for (const interface of device.configuration.interfaces) {
  // Only support devices with out multiple alternate interfaces.
  const alternate = interface.alternates[0];

  // Identify the interface implementing the USB CDC class.
  const USB_CDC_CLASS = 10;
  if (alternate.interfaceClass != USB_CDC_CLASS) {
    continue;
  }

  for (const endpoint of alternate.endpoints) {
    // Identify the bulk transfer endpoints.
    if (endpoint.type != "bulk") {
      continue;
    }

    if (endpoint.direction == "in") {
      inEndpoint = endpoint.endpointNumber;
    } else if (endpoint.direction == "out") {
      outEndpoint = endpoint.endpointNumber;
    }
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web USB','#endpoints','USBEndPoint')}}</td>
   <td>{{Spec2('Web USB')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.USBEndpoint")}}</p>
